<?php
// +-----------------------------------------------------------------------+
// | Mod Name : Download_multi                                             |
// | Mod Version : 0.5.1                                                      |
// | Mod Orignal author: Tboris                                            |
// | Mod Second author : Cestlodovic                                       |
// | Mod Version author : FlipFlip <flipflip@free.fr>                      |
// | Mod description :                                                     |
// | Ce module est bas sur le module existant pour le tlchargement,     |
// | cette version permet le tlchargement sur plusieurs pages.           |
// | Mod Addon : PclZip -> http://www.phpconcept.net/pclzip/               |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

/* Gestion de l'affichage dans include/category_default.php */
function category_default()
{
	global $conf, $user, $lang, $template;
    if($user['id'] <> 2)
    {
        // Rcupration du groupe utilisateur autoris  tlcharger les images
        $query = '
            SELECT group_id
            FROM '.USER_GROUP_TABLE.'
            WHERE user_id = '.$user['id'].'
        ;';
        $result = pwg_query($query);

        while($row = mysql_fetch_array($result))
        {
            if ( $row['group_id'] == $conf['mod_dl_multi_group_id'] )
            {
                $redirect_to = isset($_POST['redirect']) ? $_POST['redirect'] : '';
                $query = '
                    SELECT COUNT(*) AS nb_line
                    FROM '.MOD_DOWNLOAD_MULTI.'
                    WHERE id_user = '.$user['id'].'
                ;';
                $row = mysql_fetch_array(pwg_query($query));

                $template->assign_block_vars('thumbnails.download',
                    array('TITLE' => $lang['dl_title']));

                if ($row['nb_line'] > 0)
                {
                    $template->assign_block_vars('thumbnails.download.check',
                        array('NB' => $row['nb_line'],
                              'U_CAT' => duplicate_index_URL()
                        ));
                }
                
                $template->assign_block_vars('thumbnails.download.form',
                    array('INPUT_VALUE_HIGH' => 'high',
                          'INPUT_VALUE_NORMAL' => 'normal',
                          'INPUT_VALUE_THUMBNAIL' => 'thumbnail',
                          'U_CAT' => duplicate_index_URL(),
                    ));
            }
        }
    }
}

/* Contrle les valeurs envoy par le formulaire de
* slection des images
* $id_images --> Liste des images slectionn
* $cat    --> Catgorie sources
* $mode   --> Type d'images slectionnes (thumbnail, normal, hight)
* $act    --> Action effectu (ajout, tlchargement, vidage du panier) */
function controle($id_images, $cat, $mode, $act)
{
    global $template, $lang, $conf, $user;
    $template->assign_block_vars(
        'erreurs', array('LIST_ERREUR' => $lang['dl_title_erreur']));

    // Contrle si au moins une image a t choisi
    if(!isset($id_images))
    {
    	$page['section'] = '';
        include(PHPWG_ROOT_PATH.'include/menubar.inc.php');

    	$url = duplicate_index_URL();
        $template->assign_block_vars(
            'erreurs.images', 
                array(
                    'EMPTY_IMAGE' => $lang['dl_choice_image'],
                ));
        
        $template->parse('download_multi');

        include( PHPWG_ROOT_PATH.'include/page_tail.php' );  
        die();
    }

    // Contrle de la catgorie
    if(!isset($cat))
    {	
        $page['section'] = '';
        include(PHPWG_ROOT_PATH.'include/menubar.inc.php');
        
        $template->assign_block_vars(
            'erreurs.cat', array('EMPTY_CAT' => $lang['dl_empty_cat']));

        $template->parse('download_multi');
        include( PHPWG_ROOT_PATH.'include/page_tail.php' );
        die();
    }

    // Contrle de l'action  effectuer
    if(!isset($act))
    {
        $page['section'] = '';
        include(PHPWG_ROOT_PATH.'include/menubar.inc.php');

        $template->assign_block_vars(
            'erreurs.act', array('EMPTY_MODE' => $lang['dl_emtpy_act']));

        $template->parse('download_multi');
        include( PHPWG_ROOT_PATH.'include/page_tail.php' );
        die();
    }

    // Contrle du type d'image  ajouter
    if(!isset($mode))
    {
        $page['section'] = '';
        include(PHPWG_ROOT_PATH.'include/menubar.inc.php');
                
        $template->assign_block_vars(
            'erreurs.mode', array('EMPTY_MODE' => $lang['dl_emtpy_mode']));

        $template->parse('download_multi');
        include( PHPWG_ROOT_PATH.'include/page_tail.php' );
        die();
    }

    // Test le rpertoire zip_archive
    // Si il n'existe pas le script le cr
    // Action ncessaire pour rsoudre le problme de droit chez certains hbergeurs
    if(!is_dir($_SERVER['DOCUMENT_ROOT'].'/'.$conf['mod_dl_multi_rep_pwg'].'modules/download_multi/zip_archive/'))
    {
        if(!mkdir($_SERVER['DOCUMENT_ROOT'].'/'.$conf['mod_dl_multi_rep_pwg'].'modules/download_multi/zip_archive/'))
        {
            $page['section'] = '';
            include(PHPWG_ROOT_PATH.'include/menubar.inc.php');       

            $template->assign_block_vars(
                'erreurs.dir',
                    array(
                        'DIR_ERROR' => $lang['dl_dir_zip'],
                        'URL' => '<a href="http://'.$_SERVER['HTTP_HOST'].'/'.$conf['mod_dl_multi_rep_pwg'].$cat
                    ));

        $template->parse('download_multi');
        include( PHPWG_ROOT_PATH.'include/page_tail.php' );
        die();
        }
    }
    
    // Cration du rpertoire de l'utilisateur avec sont id user
    if(!is_dir($_SERVER['DOCUMENT_ROOT'].'/'.$conf['mod_dl_multi_rep_pwg'].'modules/download_multi/zip_archive/'.$user['id']))
    {
        if(!mkdir($_SERVER['DOCUMENT_ROOT'].'/'.$conf['mod_dl_multi_rep_pwg'].'modules/download_multi/zip_archive/'.$user['id']))
        {
            $page['section'] = '';
            include(PHPWG_ROOT_PATH.'include/menubar.inc.php');
        
            $template->assign_block_vars(
                'erreurs.dir',
                    array(
                        'DIR_ERROR' => $lang['dl_dir_zip'],
                        'URL' => '<a href="http://'.$_SERVER['HTTP_HOST'].'/'.$conf['mod_dl_multi_rep_pwg'].$cat
                    ));

        $template->parse('download_multi');
        include( PHPWG_ROOT_PATH.'include/page_tail.php' );
        die();
        }
    }
    clearstatcache();
}

/* Ajout de photos dans le panier
*  $id_images    --> Liste des images slectionns
*  $cat       --> Catgorie source (utilis pour le renvoie)
*  $mode      --> Type d'images ajouter (thumbnail, normal, high) */
function add_cart($id_images, $cat, $mode)
{
    // Ajoute la slection au panier
    global $conf, $user;
    switch($mode)
    {
        case 'thumbnail':
            // Insertion des vignettes dans la base de donnes
            for($i=0;$i<count($id_images);$i++)
            {              
                // Slection des informations sur l'image
                $query = '
                    SELECT file, path
                    FROM '.IMAGES_TABLE.'
                    WHERE id = \''.$id_images[$i].'\'
                ;';
                $row = mysql_fetch_array(pwg_query($query));
                
                $file = dirname('../.'.$row['path']).'/thumbnail/'.$conf['prefix_thumbnail'].$row['file'];
                
                // Taille de l'image
                $fic_size = filesize($file);
                
                $query = '
                    INSERT INTO '.MOD_DOWNLOAD_MULTI.' (id_image, id_user, filesize, type)
                    VALUES (\''.$id_images[$i].'\', \''.$user['id'].'\', \''.$fic_size.'\', \'t\')
                    ON DUPLICATE KEY UPDATE
                        id_user = \''.$user['id'].'\'
                        AND id_image = \''.$id_images[$i].'\'
                        AND type = \'t\' 
                ;';
                $result = pwg_query($query);
            }
        break;
        case 'normal':
            // Insertion des photos normal dans la base de donnes
            for($i=0;$i<count($id_images);$i++)
            {
                // Slection des informations sur l'image
                $query = '
                    SELECT file, path
                    FROM '.IMAGES_TABLE.'
                    WHERE id = \''.$id_images[$i].'\'
                ;';
                $row = mysql_fetch_array(pwg_query($query));
                
                $file = dirname('../.'.$row['path']).'/'.$row['file'];
                
                // Taille de l'image
                $fic_size = filesize($file);
                
                $query = '
                    INSERT INTO '.MOD_DOWNLOAD_MULTI.' (id_image, id_user, filesize, type)
                    VALUES (\''.$id_images[$i].'\', \''.$user['id'].'\', \''.$fic_size.'\', \'n\')
                    ON DUPLICATE KEY UPDATE
                        id_user = \''.$user['id'].'\'
                        AND id_image = \''.$id_images[$i].'\'
                        AND type = \'n\'
                ;';
                $result = pwg_query($query);
            }
        break;

        case 'high':
            // Insertion des haut dfinition dans la base de donnes
            for($i=0;$i<count($id_images);$i++)
            {
                // Slection des informations sur l'image
                $query = '
                    SELECT file, path
                    FROM '.IMAGES_TABLE.'
                    WHERE id = \''.$id_images[$i].'\'
                ;';
                $row = mysql_fetch_array(pwg_query($query));
                
                $file = dirname('../.'.$row['path']).'/pwg_high/'.$row['file'];
                // contrle si le fichier existe, dans le cas contraire
                // rien n'est insr et le traitement continue sur les images suivantes.
                if(file_exists($file))
                {              
                    // Taille de l'image
                    $fic_size = filesize($file);

                    $query = '
                        INSERT INTO '.MOD_DOWNLOAD_MULTI.' (id_image, id_user, filesize, type)
                        VALUES (\''.$id_images[$i].'\', \''.$user['id'].'\', \''.$fic_size.'\', \'h\')
                        ON DUPLICATE KEY UPDATE
                            id_user = \''.$user['id'].'\'
                            AND id_image = \''.$id_images[$i].'\'
                            AND type = \'h\'
                        ;';
                        $result = pwg_query($query);
                }
            }
        break;
        }
    $redirect_to = PHPWG_ROOT_PATH.$cat;
    redirect(empty($redirect_to) ? make_index_url() : $redirect_to);
}

/* Vidage du panier
* $cat --> Catgorie source */
function del_cart($cat)
{
    global $conf, $user;
    // Suppression des images slectionn dans une prcdente session
    $query = '
        DELETE FROM '.MOD_DOWNLOAD_MULTI.'
        WHERE id_user = \''.$user['id'].'\'
    ;';
    $result = pwg_query($query);

    // Optimisation de la table pour viter la fragmentation
    // aprs suppression d'enregistrements
    $query = '
        OPTIMIZE TABLE '.MOD_DOWNLOAD_MULTI.'
    ;';
    $result = pwg_query($query);

    // Suppression de tout les fichiers
    // dans le rpertoire utilisateur
    $dir_zip = $_SERVER['DOCUMENT_ROOT'].'/'.$conf['mod_dl_multi_rep_pwg'].'modules/download_multi/zip_archive/'.$user['id'].'/';      
    $dir = opendir($dir_zip);
    while($file = readdir($dir))
    {
        if(!is_file($file))
        {
            if($file != '.' && $file != '..')
            {
                unlink($_SERVER['DOCUMENT_ROOT'].'/'.$conf['mod_dl_multi_rep_pwg'].'modules/download_multi/zip_archive/'.$user['id'].'/'.$file);
            }
        }
    }
    clearstatcache();    
    
    $redirect_to = PHPWG_ROOT_PATH.$cat;
    redirect(empty($redirect_to) ? make_index_url() : $redirect_to);
}

/* Liste le rpertoire utilisateur
* $dir_zip --> Rpertoire de base de l'utilisateur */
function list_dir($dir_zip)
{
    global $conf, $user, $template;
    $dir = opendir($dir_zip);
    while($file = readdir($dir))
    {
        if(!is_file($file))
        {
            if($file != '.' && $file != '..')
            {
                $tab_file[] = array('file' => $file, 'date' => filemtime($dir_zip.$file));                                
            }
        }
    }
  
    if (isset($tab_file))
    { 
        $template->assign_block_vars(
                        'telechargement.formulaire',
                            array(
                                'F_ACTION' => 'index.php?act=del_userdir'
                            ));
        

        // Obtient une liste de colonnes
        foreach ($tab_file as $key => $row)
        {
            $file[$key]  = $row['file'];
            $date[$key] = $row['date'];          
        }
        
        // Tri les donnes par volume dcroissant, edition croissant
        // Ajoute $data en tant que dernier paramtre, pour trier par la cl commune
        array_multisort($file, SORT_ASC, $date, SORT_DESC, $tab_file);
                         
        foreach($tab_file as $elem)
        {            
            $template->assign_block_vars(
                            'telechargement.formulaire.list',
                                array(
                                    'FIC_CHEMIN' => 'http://'.$_SERVER['HTTP_HOST'].'/'.$conf['mod_dl_multi_rep_pwg'].'modules/download_multi/zip_archive/'.$user['id'].'/',
                                    'FIC_NAME' => $elem['file'],
                                    'FIC_DATE' => dd($elem['date'])
                                ));       
        }
    }
    else
    {   
        $template->assign_block_vars('telechargement.error', array());
    }    
    closedir($dir); 
    clearstatcache();        
}

/* Suppression des fichiers dans le
* rpertoire utilisateur
* $fic --> liste des fichiers  */
function del_userdir($fic)
{
    global $user, $conf;   
    if (isset($fic))
    {  
        for($i=0;$i<count($fic);$i++)
        {
            unlink($_SERVER['DOCUMENT_ROOT'].'/'.$conf['mod_dl_multi_rep_pwg'].'modules/download_multi/zip_archive/'.$user['id'].'/'.$fic[$i]);
        }
    }
    
    $redirect_to = PHPWG_ROOT_PATH.'modules/download_multi/panier.php?src=reload';
    redirect(empty($redirect_to) ? make_index_url() : $redirect_to);
}

/* Renvoie la date */
function dd($date)
{
    return date("d/m/Y H:i:s", $date);
}
?>